﻿//XMLResponse
function xmlHttp() {
    this.GetResponse = xmlGetResponse;
}
// 读取远程数据
function xmlGetResponse(_urlxml, _urlxsl, id) {
    var xml = loadXMLDoc(_urlxml, _urlxsl);
    var xsl = loadXMLDoc(_urlxsl, _urlxsl);
    if (window.ActiveXObject) { //ie
        ex = xml.transformNode(xsl);
        document.getElementById(id).innerHTML = ex;
    }
    else if (document.implementation && document.implementation.createDocument) { //firebox等
        xsltProcessor = new XSLTProcessor();
        xsltProcessor.importStylesheet(xsl);
        resultDocument = xsltProcessor.transformToFragment(xml, document);
        document.getElementById(id).appendChild(resultDocument);
    }
}

function loadXMLDoc(_url,_urlxsl) {
    var xhttp;
    if (window.XMLHttpRequest) {
        xhttp = new XMLHttpRequest();
    }
    else {
        xhttp = new ActiveXObject("Microsoft.XMLHTTP");
    }
    xhttp.open("GET", _url, false); //同步获取
    xhttp.send(null);

    if (_url != _urlxsl) {  //如果_url是xml的链接就添加xsl文件的引用
        node = xhttp.responseXML.createProcessingInstruction("xml-stylesheet", "href='" + _urlxsl + "' type='text/xsl'");
        xhttp.responseXML.insertBefore(node, xhttp.responseXML.childNodes[1]);
    }

       if (!xhttp.responseXML.xml) {
        //转化为dom
        try {
            if (window.ActiveXObject) {
                var xmlobject = new ActiveXObject("Microsoft.XMLDOM");
                xmlobject.async = "false";
                xmlobject.loadXML(xhttp.responseText);
                return xmlobject;
            }
            else {
                var parser = new DOMParser();
                var xmlobject = parser.parseFromString(xhttp.responseText, "text/xml");
                return xmlobject;
            }

        } catch (e) {
        }
    }
    else { return xhttp.responseXML; }
    
    //return xhttp.responseXML;

}

